signature Complex16 where {
import FixedPoint;
		    
import List;
	      
import PrimArray;
		   
import Vector;
		
struct (Complex16.Complex16 :: *) = {
    Complex16.i :: Prelude.Bit 16;
    Complex16.q :: Prelude.Bit 16
};
 
instance Complex16 Prelude.Eq Complex16.Complex16;
						       
instance Complex16 Prelude.Bits Complex16.Complex16 32;
							    
Complex16.toInt :: Prelude.Bit n -> Prelude.Int n;
							     
Complex16.toBit :: Prelude.Int n -> Prelude.Bit n;
							     
instance Complex16 Prelude.Literal Complex16.Complex16;
							    
instance Complex16 Prelude.Bounded Complex16.Complex16;
							    
Complex16.rzeroExtend :: (Prelude.Add n k m) => Prelude.Bit n -> Prelude.Bit m;
												
Complex16.rtruncate :: (Prelude.Add k m n) => Prelude.Bit n -> Prelude.Bit m;
											      
Complex16.mult :: (Prelude.Add n k n2) =>
		  Prelude.Bit n -> Prelude.Bit n -> Prelude.Bit n2;
										    
Complex16.mult_fp :: FixedPoint.FixedPoint 2 14 ->
		     FixedPoint.FixedPoint 2 14 -> FixedPoint.FixedPoint 2 14;
											 
Complex16.bits2fp :: Prelude.Bit 16 -> FixedPoint.FixedPoint 2 14;
									     
instance Complex16 Prelude.Arith Complex16.Complex16;
							  
Complex16.mul_first :: Complex16.Complex16 ->
		       Complex16.Complex16 -> Vector.Vector 4 (FixedPoint.FixedPoint 2 14);
												      
Complex16.mul_second :: Vector.Vector 4 (FixedPoint.FixedPoint 2 14) ->
			Complex16.Complex16;
					   
instance FixedPoint Prelude.Eq (FixedPoint.FixedPoint isize fsize);
										       
instance FixedPoint Prelude.Bits (FixedPoint.FixedPoint isize fsize)
		       (Prelude.TAdd isize fsize);
							     
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Bounded (FixedPoint.FixedPoint i f);
										    
instance FixedPoint (Prelude.Add i f (Prelude.TAdd i f),
			Prelude.Add 1 xxx i) =>
		       Prelude.Arith (FixedPoint.FixedPoint i f);
										  
instance FixedPoint (Prelude.Add 1 xxx i,
			Prelude.Add i f (Prelude.TAdd i f)) =>
		       Prelude.Literal (FixedPoint.FixedPoint i f);
										    
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Ord (FixedPoint.FixedPoint i f);
										
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Bitwise (FixedPoint.FixedPoint i f);
										    
instance Vector (Prelude.Eq (Prelude.PrimArray a)) =>
		   Prelude.Eq (Vector.Vector n a);
								   
instance Vector (Prelude.Bits a sa, Prelude.Mul n sa nsa) =>
		   Prelude.Bits (Vector.Vector n a) nsa;
									    
instance Vector (Prelude.Bounded a, Prelude.Bits a sa) =>
		   Prelude.Bounded (Vector.Vector n a);
									
instance Vector Prelude.PrimSelectable (Vector.Vector n a) a;
										    
instance Vector Prelude.PrimUpdateable (Vector.Vector n a) a;
										    
type (FixedPoint.FixedPoint :: # -> # -> *) _v100 _v101;
							     
type (Vector.Vector :: # -> * -> *) _v100 _v101
}
