signature Parameters where {
type (Parameters.FunctionalUnitNumber :: #) = 1;
					       
type (Parameters.LogFunctionalUnitNumber :: #) = Prelude.TLog Parameters.FunctionalUnitNumber;
												   
type (Parameters.FunctionalUnitAddr :: *) = Prelude.Bit Parameters.LogFunctionalUnitNumber;
												
type (Parameters.FunctionalUnitMask :: *) = Prelude.Bit Parameters.FunctionalUnitNumber;
											     
type (Parameters.BlockSize :: #) = 64;
				     
type (Parameters.LogBlockSize :: #) = Prelude.TLog Parameters.BlockSize;
									     
type (Parameters.BlockElements :: #) = Prelude.TMul Parameters.BlockSize Parameters.BlockSize;
												   
type (Parameters.LogBlockElements :: #) =
  Prelude.TLog (Prelude.TMul Parameters.BlockSize Parameters.BlockSize);
										   
type (Parameters.MaxBlockSize :: #) = 1024;
					  
type (Parameters.LogRowSize :: #) =
  Prelude.TAdd (Prelude.TLog Parameters.MaxBlockSize) 2;
								   
type (Parameters.PLBAddrSize :: #) = 32;
				       
type (Parameters.PLBAddr :: *) = Prelude.Bit Parameters.PLBAddrSize;
									 
type (Parameters.BurstSize :: #) = 16;
				     
type (Parameters.BlockAddr :: *) = Prelude.Bit 30
}
