#include "instructions.h"
#include "instructionParameters.h"
#include "cLib.h"

#define BramInstructionStart 0x00001111
#define BramOutputStart 0x10001111

int bramInstruction;
int bramOutput;

void initialize()
{
    bramInstruction = 0;
    bramOutput = 0;
}

void putInstruction(UInt64 x)
{
    UInt64 xShift = x >> 32;
    int x0 = (int)xShift;
    int x1 = (int)x;
    *(int *)(BramInstructionStart + bramInstruction) = x0;
    *(int *)(BramInstructionStart + bramInstruction + 1) = x1;
    bramInstruction += 2;
}

int getResponse()
{
    return *(int *)(BramOutputStart + bramOutput);
}
