signature PLBMasterWires where {
import Clocks;
		
import Environment;
		     
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import List;
	      
import ListN;
	       
import Parameters;
		 
import PrimArray;
		   
import Vector;
		
import Connectable;
		     
import GetPut;
		
interface (PLBMasterWires.PLBMasterWires :: *) = {
    PLBMasterWires.mABus :: Prelude.Bit Parameters.PLBAddrSize {-# arg_names = [],
									 result = "mABus",
									 prefixs = "",
									 always_ready  #-};
    PLBMasterWires.mBE :: Prelude.Bit 8 {-# arg_names = [],
						  result = "mBE",
						  prefixs = "",
						  always_ready  #-};
    PLBMasterWires.mRNW :: Prelude.Bit 1 {-# arg_names = [],
						   result = "mRNW",
						   prefixs = "",
						   always_ready  #-};
    PLBMasterWires.mAbort :: Prelude.Bit 1 {-# arg_names = [],
						     result = "mAbort",
						     prefixs = "",
						     always_ready  #-};
    PLBMasterWires.mBusLock :: Prelude.Bit 1 {-# arg_names = [],
						       result = "mBusLock",
						       prefixs = "",
						       always_ready  #-};
    PLBMasterWires.mCompress :: Prelude.Bit 1 {-# arg_names = [],
							result = "mCompress",
							prefixs = "",
							always_ready  #-};
    PLBMasterWires.mGuarded :: Prelude.Bit 1 {-# arg_names = [],
						       result = "mGuarded",
						       prefixs = "",
						       always_ready  #-};
    PLBMasterWires.mLockErr :: Prelude.Bit 1 {-# arg_names = [],
						       result = "mLockErr",
						       prefixs = "",
						       always_ready  #-};
    PLBMasterWires.mMSize :: Prelude.Bit 2 {-# arg_names = [],
						     result = "mMSize",
						     prefixs = "",
						     always_ready  #-};
    PLBMasterWires.mOrdered :: Prelude.Bit 1 {-# arg_names = [],
						       result = "mOrdered",
						       prefixs = "",
						       always_ready  #-};
    PLBMasterWires.mPriority :: Prelude.Bit 2 {-# arg_names = [],
							result = "mPriority",
							prefixs = "",
							always_ready  #-};
    PLBMasterWires.mRdBurst :: Prelude.Bit 1 {-# arg_names = [],
						       result = "mRdBurst",
						       prefixs = "",
						       always_ready  #-};
    PLBMasterWires.mRequest :: Prelude.Bit 1 {-# arg_names = [],
						       result = "mRequest",
						       prefixs = "",
						       always_ready  #-};
    PLBMasterWires.mSize :: Prelude.Bit 4 {-# arg_names = [],
						    result = "mSize",
						    prefixs = "",
						    always_ready  #-};
    PLBMasterWires.mType :: Prelude.Bit 3 {-# arg_names = [],
						    result = "mType",
						    prefixs = "",
						    always_ready  #-};
    PLBMasterWires.mWrBurst :: Prelude.Bit 1 {-# arg_names = [],
						       result = "mWrBurst",
						       prefixs = "",
						       always_ready  #-};
    PLBMasterWires.mWrDBus :: Prelude.Bit 32 {-# arg_names = [],
						       result = "mWrDBus",
						       prefixs = "",
						       always_ready  #-};
    PLBMasterWires.plbIN :: Prelude.Bit 1 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 32 ->
			    Prelude.Bit 3 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 1 ->
			    Prelude.Bit 1 -> Prelude.Bit 1 -> Prelude.Action {-# arg_names = [mRst,
														mAddrAck,
														mBusy,
														mErr,
														mRdBTerm,
														mRdDAck,
														mRdDBus,
														mRdWdAddr,
														mRearbitrate,
														mWrBTerm,
														mWrDAck,
														mSSize,
														sMErr,
														sMBusy],
												   always_enabled ,
												   prefixs = "",
												   always_ready  #-}
};
 
instance ListN (Prelude.Eq (Prelude.List a)) =>
		  Prelude.Eq (ListN.ListN n a);
								
instance ListN (Prelude.Bits a sa, Prelude.Mul n sa nsa) =>
		  Prelude.Bits (ListN.ListN n a) nsa;
									 
instance ListN Prelude.PrimSelectable (ListN.ListN n a) a;
										 
instance ListN Prelude.PrimUpdateable (ListN.ListN n a) a;
										 
instance Vector (Prelude.Eq (Prelude.PrimArray a)) =>
		   Prelude.Eq (Vector.Vector n a);
								   
instance Vector (Prelude.Bits a sa, Prelude.Mul n sa nsa) =>
		   Prelude.Bits (Vector.Vector n a) nsa;
									    
instance Vector (Prelude.Bounded a, Prelude.Bits a sa) =>
		   Prelude.Bounded (Vector.Vector n a);
									
instance Vector Prelude.PrimSelectable (Vector.Vector n a) a;
										    
instance Vector Prelude.PrimUpdateable (Vector.Vector n a) a;
										    
instance Connectable (Connectable.Connectable a b,
			 Connectable.Connectable c d) =>
			Connectable.Connectable (a, c) (b, d);
									       
instance Connectable (Connectable.Connectable a b) =>
			Connectable.Connectable (Vector.Vector n a) (Vector.Vector n b);
														     
instance Connectable (Connectable.Connectable a b) =>
			Connectable.Connectable (ListN.ListN n a) (ListN.ListN n b);
														 
instance Connectable Connectable.Connectable (PreludeBSV.RWire a)
			(PreludeBSV.RWire a);
						     
instance Connectable Connectable.Connectable (Prelude.ActionValue a)
			(a -> Prelude.Action);
						      
instance Connectable Connectable.Connectable (a -> Prelude.Action)
			(Prelude.ActionValue a);
							
instance GetPut Connectable.Connectable (GetPut.Get a) (GetPut.Put a);
												
instance GetPut Connectable.Connectable (GetPut.Put a) (GetPut.Get a);
												
instance GetPut (Prelude.Bits a sa) =>
		   Prelude.ClockConv (GetPut.Get a);
								  
instance GetPut (Prelude.Bits a sa) =>
		   Prelude.ClockConv (GetPut.Put a);
								  
class (Connectable.Connectable :: * -> * -> *) a b | a -> b, b -> a;
									 
type (GetPut.Get :: * -> *) _v100;
				       
type (GetPut.Put :: * -> *) _v100;
				       
type (ListN.ListN :: # -> * -> *) _v100 _v101;
						   
type (Parameters.PLBAddrSize :: #);
				  
type (Vector.Vector :: # -> * -> *) _v100 _v101
}
